# Domcom类层次结构

## Component class hierarchy
    Component  ...................  // 所有部件类的基类
    |
    |- BaseComponent  ............  // 基本部件类的基类
    |  |- Tag  ...................  // Tag基本部件类，window.Element: document.createElement，实例化函数为tag, nstag, div, p, input, text, ...
    |  |   \- Html  ..............  // Html基本部件类,实例化函数为html。
    |  |- Text  ..................  // Text基本部件类，实例化函数为txt。
    |  |  |- Comment  ............  // Comment基本部件类，实例化函数为comment。
    |  |  \- Cdata  ..............  // Cdata基本部件类，实例化函数为cdata。
    |  |- List  ..................  // List基本部件类，包含一组children部件，实例化函数为list, every, each, funcEach。
    |  |                               (each, funcEach可以产生能watch数据的响应式列表部件。)
    |  \- Nothing  ...............  // Nothing基本部件类，不产生任何Dom节点，实例化函数为nothing。
    |
    \- TransformComponent  .......  // 变换部件类的基类
       |- If  ....................  // If变换部件类，new If(test, then_, else_)，实例化函数为if_, forceIf, mergeIf, recursiveIf。
       |- Func  ..................  // Func变换部件类，new Func(func)，实例化函数为func。
       |- Case  ..................  // Case变换部件类，new Case(test, hashMap, else_)，实例化函数为case_, forceCase。
       |- Pick  ..................  // Pick变换部件类，new Pick(host, field, intialContent)，实例化函数为pick。
       |- Cond  ..................  // Cond变换部件类，new Cond(testAndComponentPairs, else_)，实例化函数为cond。
       |- Route  .................  // Route变换部件类，route(routeList..., otherwise, baseIndex)，实例化函数为route。
       \- Defer  .................  // Defer变换部件类, 方便使用Promise，new Defer(promise, fulfill, reject, init)，实例化函数为defer。

## DomNode class

DomNode不是Comonent的子类，它的作用是为一个或一组Dom节点提供一个类似于jQuery的基本接口，包含.prop, .css, .bind, .unbind等方法。.

    DomNode  .....................  // 该类代表一个或一组Dom节点，new DomNode(node) 或 new DomNode(nodes)